// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/union_container.cc.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/gpu_load_op_or_gpu_color.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_for_core.h"

namespace blink {

GPULoadOpOrGPUColor::GPULoadOpOrGPUColor() : type_(SpecificType::kNone) {}

GPUColor* GPULoadOpOrGPUColor::GetAsGPUColor() const {
  DCHECK(IsGPUColor());
  return gpu_color_;
}

void GPULoadOpOrGPUColor::SetGPUColor(GPUColor* value) {
  DCHECK(IsNull());
  gpu_color_ = value;
  type_ = SpecificType::kGPUColor;
}

GPULoadOpOrGPUColor GPULoadOpOrGPUColor::FromGPUColor(GPUColor* value) {
  GPULoadOpOrGPUColor container;
  container.SetGPUColor(value);
  return container;
}

const String& GPULoadOpOrGPUColor::GetAsGPULoadOp() const {
  DCHECK(IsGPULoadOp());
  return gpu_load_op_;
}

void GPULoadOpOrGPUColor::SetGPULoadOp(const String& value) {
  DCHECK(IsNull());
  NonThrowableExceptionState exception_state;
  const char* kValidValues[] = {
      "load",
  };
  if (!IsValidEnum(value, kValidValues, base::size(kValidValues), "GPULoadOp", exception_state)) {
    NOTREACHED();
    return;
  }
  gpu_load_op_ = value;
  type_ = SpecificType::kGPULoadOp;
}

GPULoadOpOrGPUColor GPULoadOpOrGPUColor::FromGPULoadOp(const String& value) {
  GPULoadOpOrGPUColor container;
  container.SetGPULoadOp(value);
  return container;
}

GPULoadOpOrGPUColor::GPULoadOpOrGPUColor(const GPULoadOpOrGPUColor&) = default;
GPULoadOpOrGPUColor::~GPULoadOpOrGPUColor() = default;
GPULoadOpOrGPUColor& GPULoadOpOrGPUColor::operator=(const GPULoadOpOrGPUColor&) = default;

void GPULoadOpOrGPUColor::Trace(blink::Visitor* visitor) {
  visitor->Trace(gpu_color_);
}

void V8GPULoadOpOrGPUColor::ToImpl(
    v8::Isolate* isolate,
    v8::Local<v8::Value> v8_value,
    GPULoadOpOrGPUColor& impl,
    UnionTypeConversionMode conversion_mode,
    ExceptionState& exception_state) {
  if (v8_value.IsEmpty())
    return;

  if (conversion_mode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8_value))
    return;

  if (IsUndefinedOrNull(v8_value)) {
    GPUColor* cpp_value = NativeValueTraits<GPUColor>::NativeValue(isolate, v8_value, exception_state);
    if (exception_state.HadException())
      return;
    impl.SetGPUColor(cpp_value);
    return;
  }

  if (v8_value->IsObject()) {
    GPUColor* cpp_value = NativeValueTraits<GPUColor>::NativeValue(isolate, v8_value, exception_state);
    if (exception_state.HadException())
      return;
    impl.SetGPUColor(cpp_value);
    return;
  }

  {
    V8StringResource<> cpp_value = v8_value;
    if (!cpp_value.Prepare(exception_state))
      return;
    const char* kValidValues[] = {
        "load",
    };
    if (!IsValidEnum(cpp_value, kValidValues, base::size(kValidValues), "GPULoadOp", exception_state))
      return;
    impl.SetGPULoadOp(cpp_value);
    return;
  }
}

v8::Local<v8::Value> ToV8(const GPULoadOpOrGPUColor& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.type_) {
    case GPULoadOpOrGPUColor::SpecificType::kNone:
      return v8::Null(isolate);
    case GPULoadOpOrGPUColor::SpecificType::kGPUColor:
      return ToV8(impl.GetAsGPUColor(), creationContext, isolate);
    case GPULoadOpOrGPUColor::SpecificType::kGPULoadOp:
      return V8String(isolate, impl.GetAsGPULoadOp());
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

GPULoadOpOrGPUColor NativeValueTraits<GPULoadOpOrGPUColor>::NativeValue(
    v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exception_state) {
  GPULoadOpOrGPUColor impl;
  V8GPULoadOpOrGPUColor::ToImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exception_state);
  return impl;
}

}  // namespace blink
