// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/union_container.cc.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/string_or_unrestricted_double_or_array_buffer_or_dictionary.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/dictionary.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_for_core.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_array_buffer.h"

namespace blink {

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::StringOrUnrestrictedDoubleOrArrayBufferOrDictionary() : type_(SpecificType::kNone) {}

DOMArrayBuffer* StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::GetAsArrayBuffer() const {
  DCHECK(IsArrayBuffer());
  return array_buffer_;
}

void StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SetArrayBuffer(DOMArrayBuffer* value) {
  DCHECK(IsNull());
  array_buffer_ = value;
  type_ = SpecificType::kArrayBuffer;
}

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::FromArrayBuffer(DOMArrayBuffer* value) {
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary container;
  container.SetArrayBuffer(value);
  return container;
}

Dictionary StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::GetAsDictionary() const {
  DCHECK(IsDictionary());
  return dictionary_;
}

void StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SetDictionary(Dictionary value) {
  DCHECK(IsNull());
  dictionary_ = value;
  type_ = SpecificType::kDictionary;
}

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::FromDictionary(Dictionary value) {
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary container;
  container.SetDictionary(value);
  return container;
}

const String& StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::GetAsString() const {
  DCHECK(IsString());
  return string_;
}

void StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SetString(const String& value) {
  DCHECK(IsNull());
  string_ = value;
  type_ = SpecificType::kString;
}

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::FromString(const String& value) {
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary container;
  container.SetString(value);
  return container;
}

double StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::GetAsUnrestrictedDouble() const {
  DCHECK(IsUnrestrictedDouble());
  return unrestricted_double_;
}

void StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SetUnrestrictedDouble(double value) {
  DCHECK(IsNull());
  unrestricted_double_ = value;
  type_ = SpecificType::kUnrestrictedDouble;
}

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::FromUnrestrictedDouble(double value) {
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary container;
  container.SetUnrestrictedDouble(value);
  return container;
}

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::StringOrUnrestrictedDoubleOrArrayBufferOrDictionary(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&) = default;
StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::~StringOrUnrestrictedDoubleOrArrayBufferOrDictionary() = default;
StringOrUnrestrictedDoubleOrArrayBufferOrDictionary& StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::operator=(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&) = default;

void StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::Trace(blink::Visitor* visitor) {
  visitor->Trace(array_buffer_);
}

void V8StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::ToImpl(
    v8::Isolate* isolate,
    v8::Local<v8::Value> v8_value,
    StringOrUnrestrictedDoubleOrArrayBufferOrDictionary& impl,
    UnionTypeConversionMode conversion_mode,
    ExceptionState& exception_state) {
  if (v8_value.IsEmpty())
    return;

  if (conversion_mode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8_value))
    return;

  if (v8_value->IsArrayBuffer()) {
    DOMArrayBuffer* cpp_value = V8ArrayBuffer::ToImpl(v8::Local<v8::Object>::Cast(v8_value));
    impl.SetArrayBuffer(cpp_value);
    return;
  }

  if (IsUndefinedOrNull(v8_value) || v8_value->IsObject()) {
    Dictionary cpp_value = NativeValueTraits<Dictionary>::NativeValue(isolate, v8_value, exception_state);
    if (exception_state.HadException())
      return;
    impl.SetDictionary(cpp_value);
    return;
  }

  if (v8_value->IsNumber()) {
    double cpp_value = NativeValueTraits<IDLUnrestrictedDouble>::NativeValue(isolate, v8_value, exception_state);
    if (exception_state.HadException())
      return;
    impl.SetUnrestrictedDouble(cpp_value);
    return;
  }

  {
    V8StringResource<> cpp_value = v8_value;
    if (!cpp_value.Prepare(exception_state))
      return;
    impl.SetString(cpp_value);
    return;
  }
}

v8::Local<v8::Value> ToV8(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.type_) {
    case StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SpecificType::kNone:
      return v8::Null(isolate);
    case StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SpecificType::kArrayBuffer:
      return ToV8(impl.GetAsArrayBuffer(), creationContext, isolate);
    case StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SpecificType::kDictionary:
      return impl.GetAsDictionary().V8Value();
    case StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SpecificType::kString:
      return V8String(isolate, impl.GetAsString());
    case StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::SpecificType::kUnrestrictedDouble:
      return v8::Number::New(isolate, impl.GetAsUnrestrictedDouble());
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

StringOrUnrestrictedDoubleOrArrayBufferOrDictionary NativeValueTraits<StringOrUnrestrictedDoubleOrArrayBufferOrDictionary>::NativeValue(
    v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exception_state) {
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary impl;
  V8StringOrUnrestrictedDoubleOrArrayBufferOrDictionary::ToImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exception_state);
  return impl;
}

}  // namespace blink
