// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_STRING_OR_UNRESTRICTED_DOUBLE_OR_ARRAY_BUFFER_OR_DICTIONARY_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_STRING_OR_UNRESTRICTED_DOUBLE_OR_ARRAY_BUFFER_OR_DICTIONARY_H_

#include "base/optional.h"
#include "third_party/blink/renderer/bindings/core/v8/dictionary.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_binding_for_core.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/heap/handle.h"

namespace blink {

class DOMArrayBuffer;

class MODULES_EXPORT StringOrUnrestrictedDoubleOrArrayBufferOrDictionary final {
  DISALLOW_NEW();
 public:
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsArrayBuffer() const { return type_ == SpecificType::kArrayBuffer; }
  DOMArrayBuffer* GetAsArrayBuffer() const;
  void SetArrayBuffer(DOMArrayBuffer*);
  static StringOrUnrestrictedDoubleOrArrayBufferOrDictionary FromArrayBuffer(DOMArrayBuffer*);

  bool IsDictionary() const { return type_ == SpecificType::kDictionary; }
  Dictionary GetAsDictionary() const;
  void SetDictionary(Dictionary);
  static StringOrUnrestrictedDoubleOrArrayBufferOrDictionary FromDictionary(Dictionary);

  bool IsString() const { return type_ == SpecificType::kString; }
  const String& GetAsString() const;
  void SetString(const String&);
  static StringOrUnrestrictedDoubleOrArrayBufferOrDictionary FromString(const String&);

  bool IsUnrestrictedDouble() const { return type_ == SpecificType::kUnrestrictedDouble; }
  double GetAsUnrestrictedDouble() const;
  void SetUnrestrictedDouble(double);
  static StringOrUnrestrictedDoubleOrArrayBufferOrDictionary FromUnrestrictedDouble(double);

  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&);
  ~StringOrUnrestrictedDoubleOrArrayBufferOrDictionary();
  StringOrUnrestrictedDoubleOrArrayBufferOrDictionary& operator=(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kArrayBuffer,
    kDictionary,
    kString,
    kUnrestrictedDouble,
  };
  SpecificType type_;

  Member<DOMArrayBuffer> array_buffer_;
  Dictionary dictionary_;
  String string_;
  double unrestricted_double_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8StringOrUnrestrictedDoubleOrArrayBufferOrDictionary final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const StringOrUnrestrictedDoubleOrArrayBufferOrDictionary&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrUnrestrictedDoubleOrArrayBufferOrDictionary& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrUnrestrictedDoubleOrArrayBufferOrDictionary& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<StringOrUnrestrictedDoubleOrArrayBufferOrDictionary> : public NativeValueTraitsBase<StringOrUnrestrictedDoubleOrArrayBufferOrDictionary> {
  MODULES_EXPORT static StringOrUnrestrictedDoubleOrArrayBufferOrDictionary NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static StringOrUnrestrictedDoubleOrArrayBufferOrDictionary NullValue() { return StringOrUnrestrictedDoubleOrArrayBufferOrDictionary(); }
};

template <>
struct V8TypeOf<StringOrUnrestrictedDoubleOrArrayBufferOrDictionary> {
  typedef V8StringOrUnrestrictedDoubleOrArrayBufferOrDictionary Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::StringOrUnrestrictedDoubleOrArrayBufferOrDictionary)

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_STRING_OR_UNRESTRICTED_DOUBLE_OR_ARRAY_BUFFER_OR_DICTIONARY_H_
