// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/make_names.cc.tmpl
// and input files:
//   ../../third_party/blink/renderer/core/editing/enter_key_hint_names.json5


#include "third_party/blink/renderer/core/enter_key_hint_names.h"

#include "base/stl_util.h"  // for base::size()
#include "third_party/blink/renderer/platform/wtf/std_lib_extras.h"

namespace blink {
namespace enter_key_hint_names {

void* names_storage[kNamesCount * ((sizeof(AtomicString) + sizeof(void *) - 1) / sizeof(void *))];

const AtomicString& kDone = reinterpret_cast<AtomicString*>(&names_storage)[0];
const AtomicString& kEnter = reinterpret_cast<AtomicString*>(&names_storage)[1];
const AtomicString& kGo = reinterpret_cast<AtomicString*>(&names_storage)[2];
const AtomicString& kNext = reinterpret_cast<AtomicString*>(&names_storage)[3];
const AtomicString& kPrevious = reinterpret_cast<AtomicString*>(&names_storage)[4];
const AtomicString& kSearch = reinterpret_cast<AtomicString*>(&names_storage)[5];
const AtomicString& kSend = reinterpret_cast<AtomicString*>(&names_storage)[6];

void Init() {
  static bool is_loaded = false;
  if (is_loaded) return;
  is_loaded = true;

  struct NameEntry {
    const char* name;
    unsigned hash;
    unsigned char length;
  };

  static const NameEntry kNames[] = {
    { "done", 11685723, 4 },
    { "enter", 3509546, 5 },
    { "go", 16685295, 2 },
    { "next", 13682113, 4 },
    { "previous", 8004999, 8 },
    { "search", 6906057, 6 },
    { "send", 3212636, 4 },
  };

  for (size_t i = 0; i < base::size(kNames); ++i) {
    StringImpl* impl = StringImpl::CreateStatic(kNames[i].name, kNames[i].length, kNames[i].hash);
    void* address = reinterpret_cast<AtomicString*>(&names_storage) + i;
    new (address) AtomicString(impl);
  }
}

}  // namespace enter_key_hint_names
}  // namespace blink
