// Copyright 2018 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_RENDERER_CORE_FRAME_TEST_REPORT_BODY_H_
#define THIRD_PARTY_BLINK_RENDERER_CORE_FRAME_TEST_REPORT_BODY_H_

#include "third_party/blink/renderer/core/frame/report_body.h"

namespace blink {

class TestReportBody : public ReportBody {
  DEFINE_WRAPPERTYPEINFO();

 public:
  TestReportBody(const String& message) : message_(message) {}

  ~TestReportBody() override = default;

  String message() const { return message_; }

 private:
  const String message_;
};

}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_CORE_FRAME_TEST_REPORT_BODY_H_
